Subject: Re: bug#32803: 26.1.50; cl-do: Add more literature in docstring

From: Tino Calancha <[email-masked]>
Date: Mon, 24 Sep 2018 19:17:41 +0900

Eli Zaretskii <[email-masked]> writes:

>> Cc: eli zaretskii <[email-masked]>
>> From: Tino Calancha <[email-masked]>
>> Date: Sun, 23 Sep 2018 00:02:50 +0900
>> 
>> Well, the subject say everything... the docstring of cl-do/cl-do*
>> resembles one of my phone calls :-(
>> 
>> Considering their names (do), it might be useful talk a bit about
>> what the macros do :-)
>> There is also room to say something on their arguments.
>
> Thanks.  My suggestion is to copy the description from the first
> paragraph of what the CL manual says.
It's very precise.  Thank you.
I just added that the whole loop is wrapped inside a `nil' block.
> I leave it to you to decide whether a link to the Info manual is
> needed, after these changes.
It's worth to keep it so that users can take a look on the
provided examples.

I will push the following in a couple of days in case no more
activity in this thread:
--8<-----------------------------cut here---------------start------------->8---
commit 805adebd1ff999358e016dff8d60751aba657262
Author: Tino Calancha <[email-masked]>
Date:   Mon Sep 24 19:09:29 2018 +0900

    * lisp/emacs-lisp/cl-macs.el(cl-do, cl-do*): Update docstring

diff --git a/lisp/emacs-lisp/cl-macs.el b/lisp/emacs-lisp/cl-macs.el
index 0854e665b9..10bc611325 100644
--- a/lisp/emacs-lisp/cl-macs.el
+++ b/lisp/emacs-lisp/cl-macs.el
@@ -1745,7 +1745,21 @@ cl--loop-build-ands
 
 ;;;###autoload
 (defmacro cl-do (steps endtest &rest body)
-  "The Common Lisp `do' loop.
+  "Bind variables and run BODY forms until END-TEST returns non-nil.
+First, each VAR is bound to the associated INIT value as if by a `let' form.
+Then, in each iteration of the loop, the END-TEST is evaluated; if true,
+the loop is finished.  Otherwise, the BODY forms are evaluated, then each
+VAR is set to the associated STEP expression (as if by a `cl-psetq'
+form) and the next iteration begins.
+
+Once the END-TEST becomes true, the RESULT forms are evaluated (with
+the VARs still bound to their values) to produce the result
+returned by `cl-do'.
+
+Note that the entire loop is enclosed in an implicit `nil' block, so
+that you can use `cl-return' to exit at any time.
+
+For more details, see `cl-do' description in Info node `(cl) Iteration'.
 
 \(fn ((VAR INIT [STEP])...) (END-TEST [RESULT...]) BODY...)"
   (declare (indent 2)
@@ -1757,7 +1771,22 @@ cl-do
 
 ;;;###autoload
 (defmacro cl-do* (steps endtest &rest body)
-  "The Common Lisp `do*' loop.
+  "Bind variables and run BODY forms until END-TEST returns non-nil.
+First, each VAR is bound to the associated INIT value as if by a `let*' form.
+Then, in each iteration of the loop, the END-TEST is evaluated; if true,
+the loop is finished.  Otherwise, the BODY forms are evaluated, then each
+VAR is set to the associated STEP expression (as if by a `setq'
+form) and the next iteration begins.
+
+Once the END-TEST becomes true, the RESULT forms are evaluated (with
+the VARs still bound to their values) to produce the result
+returned by `cl-do*'.
+
+Note that the entire loop is enclosed in an implicit `nil' block, so
+that you can use `cl-return' to exit at any time.
+
+This is to `cl-do' what `let*' is to `let'.
+For more details, see `cl-do*' description in Info node `(cl) Iteration'.
 
 \(fn ((VAR INIT [STEP])...) (END-TEST [RESULT...]) BODY...)"
   (declare (indent 2) (debug cl-do))

--8<-----------------------------cut here---------------end--------------->8---
In GNU Emacs 26.1.50 (build 20, x86_64-pc-linux-gnu, GTK+ Version 3.22.11)
Repository revision: 41cdda22c78eb0b00612ce25cdb356dd64322fcc